 /*
 * file      : src/main.c
 * project   : tnt
 * with      : Gtk-3
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TNT - INDIQUEZ ICI CE QUE FAIT LE PROGRAMME
 * GNU General Public License
 *
 * This file is part of TNT.
 *
 * TNT is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * TNT is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TNT.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <glib.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_dvbtv/lib.h"
#endif

#include "global.h"
#include "chan.h"
#include "stream.h"
#include "configuser.h"
#include "win_scan.h"
#include "win_about.h"
#include "builder.h"


GtkBuilder	*GtkBuilderProjet = NULL;
GtkWidget	*WindMain = NULL;


KEYS keys = {
	FALSE,		// gboolean	BoolGDKPress
	FALSE,		// gboolean	BoolGDK_Control_L_R
	FALSE,		// gboolean	BoolGDK_Control_A
	FALSE,		// gboolean	BoolGDK_Shift_L_R
	FALSE,		// gboolean	BoolGDK_Shift_L
	FALSE,		// gboolean	BoolGDK_Shift_R
	0,			// guint	keyval
};



typedef struct {
	GtkWidget			*Adr_scroll;				// Adresse
	GtkListStore		*Adr_List_Store;			// Adresse
	GtkTreeModel		*Adr_Tree_Model;			// Adresse
	GtkTreeSelection	*Adr_Line_Selected;			// Adresse
	GtkWidget			*Adr_TreeView;				// Adresse

} VAR_FILE;

VAR_FILE var_file;

enum
{
	COLUMN_CHAN_SELECT = 0,
	COLUMN_CHAN_NAME,
	COLUMN_CHAN_NUM
};


gboolean bool_hide_left = FALSE;

gboolean on_wind_main_button_press_event( GtkWidget *treeview, GdkEventButton *event, gpointer data )
{
	gboolean            bool_click_gauche = (event->button == 1);
	gboolean            bool_click_centre = (event->button == 2);
	gboolean            bool_click_droit = (event->button == 3);

	if( TRUE == bool_click_gauche )
		g_print("bool_click_gauche\n");
	else if( TRUE == bool_click_centre )
		g_print("bool_click_centre\n");
	else if( TRUE == bool_click_droit )
		g_print("bool_click_droit\n");

	if( TRUE == bool_click_gauche ) {
		bool_hide_left = TRUE == bool_hide_left ? FALSE : TRUE;
		if( TRUE == bool_hide_left ) {
			gtk_widget_show( GTK_WIDGET (GLADE_GET_OBJECT("viewport_channels")));
			gtk_widget_hide( GTK_WIDGET (GLADE_GET_OBJECT("viewport_channels")));
		}
		else {
			gtk_widget_show( GTK_WIDGET (GLADE_GET_OBJECT("viewport_channels")));
		}
	}

	return TRUE;
}

gboolean bool_zoom = FALSE;

gboolean on_wind_main_key_press_event( GtkWidget *widget, GdkEventKey *kevent, gpointer user_data )
{
	g_print( "kevent->keyval = %d\n", kevent->keyval );
	g_print( "kevent->keyval = %c\n", kevent->keyval );
	if( 65307 == kevent->keyval ) {	// ESC = 65307
		if( TRUE == bool_zoom ) {
			gdk_window_unfullscreen( gtk_widget_get_window(WindMain) );
			gtk_widget_show( GTK_WIDGET (GLADE_GET_OBJECT("viewport_channels")));
			gtk_widget_show( GTK_WIDGET (GLADE_GET_OBJECT("menubar1")));
			bool_hide_left = FALSE;

			bool_zoom = TRUE == bool_zoom ? FALSE : TRUE;
		}
	}
	else if( 122 == kevent->keyval ) {
		bool_zoom = TRUE == bool_zoom ? FALSE : TRUE;

		if( TRUE == bool_zoom ) {
			gdk_window_set_fullscreen_mode( gtk_widget_get_window(WindMain), GDK_FULLSCREEN_ON_CURRENT_MONITOR );
			gdk_window_fullscreen( gtk_widget_get_window(WindMain) );
			gtk_widget_hide( GTK_WIDGET (GLADE_GET_OBJECT("viewport_channels")));
			gtk_widget_hide( GTK_WIDGET (GLADE_GET_OBJECT("menubar1")));
			bool_hide_left = TRUE;
		}
		else {
			gdk_window_unfullscreen( gtk_widget_get_window(WindMain) );
			gtk_widget_show( GTK_WIDGET (GLADE_GET_OBJECT("viewport_channels")));
			gtk_widget_show( GTK_WIDGET (GLADE_GET_OBJECT("menubar1")));
			bool_hide_left = FALSE;
		}
	}
	return TRUE;
}
gboolean on_wind_main_key_release_event( GtkWidget *widget, GdkEventKey *kevent, gpointer user_data )
{
	return TRUE;
}

// ---------------------------------------------
// StructClass->Id = wind_main
// ---------------------------------------------
void main_remove( void )
{
	if( TRUE == StreamTv_get_is_bool_go_tv() ) {
		g_print( "\tStop TV ...\n");
		StreamTv_notify_bool_go_tv( FALSE );
		sleep( 2 );
	}
	g_print( "\n\nmain_remove()\n");
	g_print( "\tchan_remove_list()\n");
	chan_remove_list();

	g_print ("Recuperation position et taille de la fenetre\n");
	gdk_window_get_root_origin( gtk_widget_get_window(WindMain), &Config.WinPos_X, &Config.WinPos_Y );
	// gdk_window_get_size( gtk_widget_get_root_window(WindMain), &Config.WinWidth, &Config.WinHeight );
	Config.WinWidth  = gdk_window_get_width( gtk_widget_get_window(WindMain) );
	Config.WinHeight = gdk_window_get_height( gtk_widget_get_window(WindMain) );

	g_print ("Sauvegarde de la configuration\n");
	config_save ();
	g_print ("config_remove ()\n");
	config_remove ();

}

gboolean on_wind_main_delete_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	main_remove();
	gtk_main_quit ();
	return( FALSE );
}
gboolean on_wind_main_destroy_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	main_remove();
	gtk_main_quit ();
	return( FALSE );
}
void on_imagemenuitem_quit_activate( GtkImageMenuItem *menuitem, gpointer user_data )
{
	main_remove();
	gtk_main_quit ();
}

void on_menuitem_load_channel_conf_activate( GtkImageMenuItem *menuitem, gpointer user_data )
{
	g_print("on_menuitem_load_channel_conf_activate\n");
	winscan_create( WindMain, var_file.Adr_List_Store );
}
void on_menuitem_help_activate( GtkImageMenuItem *menuitem, gpointer user_data )
{
	WinAbout_open();
}

static void item_toggled( GtkCellRendererToggle *cell, gchar *path_str, gpointer data )
{
	GtkTreeModel	*model = (GtkTreeModel *)data;
	GtkTreePath		*path = gtk_tree_path_new_from_string (path_str);
	GtkTreeIter		iter,iter_remove;
	gint			*column;
	gboolean		valid;
	gboolean		toggle_item;
	gchar			*NameChan;

	// select
	column = g_object_get_data (G_OBJECT (cell), "column");
	gtk_tree_model_get_iter (model, &iter, path);
	gtk_tree_model_get (model, &iter, column, &toggle_item, -1);

	// get name
	gtk_tree_model_get (model, &iter, COLUMN_CHAN_NAME, &NameChan, -1);

	if( FALSE == toggle_item ) {
		// remove if select
		valid = gtk_tree_model_get_iter_first (var_file.Adr_Tree_Model, &iter_remove);
		while (valid) {
			gtk_tree_model_get (var_file.Adr_Tree_Model, &iter_remove, COLUMN_CHAN_SELECT, &toggle_item, -1);
			if( toggle_item == TRUE ) {
				gtk_list_store_set (GTK_LIST_STORE (model), &iter_remove, COLUMN_CHAN_SELECT, FALSE, -1);
				break;
			}
			valid = gtk_tree_model_iter_next (var_file.Adr_Tree_Model, &iter_remove);
		}
		toggle_item = TRUE;
	}
	else {
		toggle_item = FALSE;
	}
	gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_CHAN_SELECT, toggle_item, -1);
	gtk_tree_path_free (path);
	while (gtk_events_pending()) gtk_main_iteration();

	if( TRUE == toggle_item ) {
		// StreamRecord_go( NameChan );
		StreamTv_play( NameChan );
	}
	else {
		StreamTv_notify_bool_go_tv( FALSE );
	}
}

static void file_add_columns_scrolledwindow (GtkTreeView *treeview)
{
	GtkTreeModel      *model = gtk_tree_view_get_model (treeview);
	GtkCellRenderer   *renderer;
	// GtkTreeViewColumn *column;
	gint	col_offset;

	// COLUMN_CHAN_SELECT
	renderer = gtk_cell_renderer_toggle_new ();
	gtk_cell_renderer_toggle_set_radio( GTK_CELL_RENDERER_TOGGLE( renderer ), TRUE);
	g_object_set (renderer, "xalign", 0.5, NULL);
	g_object_set_data (G_OBJECT (renderer), "column", (gint *)COLUMN_CHAN_SELECT);
	g_signal_connect (renderer, "toggled", G_CALLBACK (item_toggled), model);
	col_offset = gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
															-1, "",
															renderer,
															"active",
															COLUMN_CHAN_SELECT,
															NULL);
// 	column = gtk_tree_view_get_column (GTK_TREE_VIEW (treeview), col_offset - 1);
// 	gtk_tree_view_column_set_fixed_width (GTK_TREE_VIEW_COLUMN (column), 50);

	// COLUMN_CHAN_NAME
	renderer = gtk_cell_renderer_text_new ();
	g_object_set (renderer, "xalign", 0.0, NULL);
	// g_object_set_data (G_OBJECT (renderer), "column", (gint *)COLUMN_CHAN_NAME);
	col_offset = gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
															-1, "Channels",
															renderer, "text",COLUMN_CHAN_NAME,
															NULL);
	// column = gtk_tree_view_get_column (GTK_TREE_VIEW (treeview), col_offset - 1);
	// gtk_tree_view_column_set_fixed_width (GTK_TREE_VIEW_COLUMN (column), 50);
	// gtk_tree_view_append_column (treeview, column);
	col_offset ++;

}

void add_to_treeview( gboolean p_bool, gchar *p_str )
{
	GtkTreeIter	iter;

	gtk_list_store_append (var_file.Adr_List_Store, &iter);
	gtk_list_store_set (var_file.Adr_List_Store, &iter,
			COLUMN_CHAN_SELECT,	p_bool,
			COLUMN_CHAN_NAME,	p_str,
			-1);
}

void on_scrolledwindow_channels_realize( GtkWidget *widget, gpointer user_data )
{
	GtkListStore *store;
	GtkTreeModel *model;
	GtkWidget    *treeview;

	var_file.Adr_scroll = widget;
	var_file.Adr_List_Store = store =
	gtk_list_store_new(
		COLUMN_CHAN_NUM,
		G_TYPE_BOOLEAN,
		G_TYPE_STRING,
		G_TYPE_POINTER
		);
	var_file.Adr_Tree_Model = model = GTK_TREE_MODEL (store);
	var_file.Adr_TreeView =
	treeview = gtk_tree_view_new_with_model (model);
	gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview), TRUE);
	// GTK_SELECTION_MULTIPLE
	// GTK_SELECTION_BROWSE
	gtk_tree_selection_set_mode (gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)), GTK_SELECTION_BROWSE);
	g_object_unref (model);
	gtk_container_add (GTK_CONTAINER (widget), treeview);
	file_add_columns_scrolledwindow (GTK_TREE_VIEW (treeview));

	gtk_widget_show_all (widget);
}

void AnalyseCommandLine( gint argc, gchar *argv[] )
{
	gint	 i;

	if( optind < argc ) {

		for( i = optind; i < argc; i++ ) {
			// VERBOSE MODE
			if( 0 == strcmp( argv[i], "-verbose" )) {
				OptionsCommandLine.BoolVerboseMode = TRUE;
			}
			// VERSION MODE
			else if( 0 == strcmp( argv[i], "-version" ) || 0 == strcmp( argv[i], "-v" )) {
				OptionsCommandLine.BoolVersionMode = TRUE;
			}
			// HELP MODE
			else if( 0 == strcmp( argv[i], "-help" ) || 0 == strcmp( argv[i], "-h" )) {
				OptionsCommandLine.BoolHelpMode = TRUE;
			}
		}
	}
}

/* gint main (gint argc, gchar *argv[], gchar **envp)
 *
 * argc  designe le nombre d'arguments transmis au moment du lancement de l'executable
 * argv  designe le vecteur contenant les differents arguments
 * envp  designe le vecteur contenant les informations sur l'environnement
 */
gint main( gint argc, gchar *argv[], gchar **envp )
{
	gchar	*PackageVersion = NULL;

	g_print( "%s :: %s (line = %d)\n", __FILE__, __FUNCTION__, __LINE__ );
	g_print( "\n" );
	g_print( "***************************\n" );
	g_print( "%s %s\n", PACKAGE, VERSION );
	g_print( "***************************\n" );
	g_print( "%s %s compiled at %s %s\n", PACKAGE, VERSION, __DATE__, __TIME__ );
	g_print( "Compiler: gcc %s\n", __VERSION__ );
	g_print( "***************************\n" );
	g_print( "Gtk version  = %d.%d.%d\n", GTK_MAJOR_VERSION, GTK_MICRO_VERSION, GTK_MINOR_VERSION );
	g_print( "Glib version = %d.%d.%d\n", GLIB_MAJOR_VERSION, GLIB_MICRO_VERSION, GLIB_MINOR_VERSION );
	g_print( "***************************\n\n" );
#ifdef ENABLE_NLS
	g_print( "ENABLE_NLS OK\n" );
	g_print( "\tGETTEXT_PACKAGE    = %s\n", GETTEXT_PACKAGE );
	g_print( "\tLOCALE_DIR         = %s\n", LOCALE_DIR );

	setlocale( LC_ALL, "" );
	bindtextdomain( GETTEXT_PACKAGE, LOCALE_DIR );
	bind_textdomain_codeset( GETTEXT_PACKAGE, "UTF-8" );
	textdomain( GETTEXT_PACKAGE );
#else
	// g_error( "ENABLE_NLS IS NOT OK \n \n " );
#endif
	AnalyseCommandLine( argc, argv );
	if( TRUE == OptionsCommandLine.BoolVersionMode || TRUE ==  OptionsCommandLine.BoolHelpMode ) {
		g_print( "\n----------------------\n" );
		g_print( "%s\n", PACKAGE_STRING );
		g_print( "----------------------\n" );

		if( TRUE ==  OptionsCommandLine.BoolHelpMode ) {
			g_print( "\nHELP MODE:\n" );
			g_print( "\t-help    -h Displays this help section and exits\n" );
			g_print( "\t-version -v Displays the version of the program and exits\n" );
			g_print( "\t-verbose    Activate verbose mode\n" );
		}
		g_print( "\n" );
		exit( EXIT_SUCCESS );
	}

	config_read();

	setlocale( LC_ALL, "" );
	gtk_init( &argc, &argv );


	if( NULL == (GtkBuilderProjet = Builder_open( PACKAGE_NAME_GLADE, GtkBuilderProjet ))) {
		return( EXIT_FAILURE );
	}

	gtk_builder_connect_signals( GtkBuilderProjet, NULL );
 	WindMain = GTK_WIDGET( gtk_builder_get_object( GtkBuilderProjet, "wind_main" ));

	// REDIMENSIONNER LA FENETRE
	gtk_window_resize(GTK_WINDOW(WindMain), Config.WinWidth, Config.WinHeight);
	// PLACER LA FENETRE
	gtk_window_move(GTK_WINDOW(WindMain), Config.WinPos_X, Config.WinPos_Y);
	// icon apply
	libutils_set_default_icone_to_win( WindMain );

	PackageVersion = g_strdup_printf( "dvbtv  -  %s", VERSION );
	gtk_window_set_title( GTK_WINDOW( WindMain ), PackageVersion );
	g_free( PackageVersion );
	PackageVersion = NULL;

	gtk_widget_show( WindMain );

#ifdef ENABLE_XDG
	xdg_print_list_config_path();
	xdg_print_list_data_path();
#endif

	if( FALSE == chan_read() )
		winscan_create( WindMain, var_file.Adr_List_Store );

	gtk_main();

	exit( EXIT_SUCCESS );
}

